// DRB 02-Dec-2009
// Using the TI FFT function

#include <stdio.h>
#include <math.h>
#define N 16
#define RADIX 2
#define PI 3.14159265358979
// complex typedef
typedef struct {
	float re,im;
} COMPLEX;

// align data (nothing works if you omit these pragma!!!!!!!!!!)
#pragma DATA_ALIGN(w,sizeof(COMPLEX))   //align w
#pragma DATA_ALIGN(x,sizeof(COMPLEX))	//align x

// function prototypes
void cfftr2_dit(COMPLEX*, COMPLEX*, short);
void bitrev(COMPLEX*, short*, int);
void digitrev_index(short*, int, int);

// global variables
COMPLEX w[N/RADIX];			    // array of complex twiddle factors
COMPLEX x[N]; 				    // array of complex FFT input/output samples
float DELTA = 2.0*PI/N;
short iw[N/2],ix[N];			// indices for bit reversal
int i,n;

void main(void)
{

	// compute first N/2 twiddle factors
 	for(i=0;i<N/RADIX;i++){
   		w[i].re = cos(DELTA*i);		    
   		w[i].im = sin(DELTA*i);		// negative imag component
  	}	

	// initialize complex FFT input array with known values
	for (i=0;i<N;i++){
		//x[i].re = cos(PI/2*i);
		if (i<N/2) 
			x[i].re = i;
		else
			x[i].re = 0;
		x[i].im = 0;
	}

 	digitrev_index(iw,N/RADIX,RADIX);//produces index for bitrev() W 
 	bitrev(w,iw,N/RADIX);		    //bit reverse W 
 	cfftr2_dit(x,w,N) ;			    //TI floating-pt complex FFT 
 	digitrev_index(ix, N, RADIX);	    //produces index for bitrev() X 
 	bitrev(x,ix,N);			    //freq scrambled->bit-reverse X

}
